;(function (win, doc, $, undefined) {
    function transPre(){
        var S = document.createElement('div').style;
        var p = ['t','webkitT','MozT','msT','OT'];
        var v = 'ransform';
        var i = 0;
        var k;
        for(;i<p.length;i++){
            k = p[i] + v;
            if( k in S ){
                return p[i];
            }
        }
        return false;
    }
    function transKey( v ){
        var v = v || 'ransform';
        var p = transPre();
        if( p === false ){
            return false;
        }
        return p + v;
    }
    function tranEndKey(){
        var k = transPre();
        if( k === false ){
            return false;
        }
        var a = {
            't'         : 'transitionend' ,
            'webkitT'   : 'webkitTransitionEnd',
            'MozT'      : 'transitionend',
            'msT'       : 'MSTransitionEnd',
            'OT'        : 'otransitionend'
        };
        return a[ k ] || false;
    }
    win.ecom = win.ecom || {};
    var wise = win.ecom.wise = win.ecom.wise || {};

    var C = win.ecom.wise.collect = {};
    var actionTypeMapping = {
        'v'         : 1,
        'poi'       : 2,
        'dianping'  : 3
    };
    var getActionType = function () {
        var action = wise.PARAMS.router.split('/')[1];
        return actionTypeMapping[action] || 1;
    };
    var getAjaxParam = function ($elem, $li, id) {
        var data = $li.attr('data-collect');
        if (data) {
            return eval('('+data+')');
        } else {
            return {};
        }
    };
    var addSuccess = function ($elem, json) {
        if (!$elem.hasClass('on')) {
            $elem.addClass('on');
        }

        if (json.data && json.data.pk_id) {
            $elem.attr('data-pk-id', json.data.pk_id);
        }
    };

    var removeSuccess = function ($elem, json) {
        $elem.removeClass('on');
        $elem.attr('data-pk-id', '');
    };
    
    C.handleClickEvent = function ($elem, id, $li) {
        var succFunc = function (json) {
            if (json.code) {
                return alert(json.msg || ('请求错误，错误码：' + json.code));
            }
            // handle success
            if (action == 'add') {
                addSuccess($elem, json);
            } else {
                removeSuccess($elem, json);
            }
        };
        var failFunc = function (o, info) {
            alert('请求失败.' + (info || ''));
        };
        var ajaxParam = getAjaxParam($elem, $li, id);
        var action = 'add';
        if ($elem.hasClass('on')) { // 已经是选中状态，则是删除操作
            action = 'remove';
            ajaxParam.pk_id = $elem.attr('data-pk-id') || 0; // 根据主键删除
        }
        var ajaxOpt = {};
            ajaxOpt.type = 'POST';
            ajaxOpt.dataType = 'json';
            ajaxOpt.url = '/collect/' + action;
            ajaxOpt.data = ajaxParam;
            ajaxOpt.success = succFunc;
            ajaxOpt.error = failFunc;
        $.ajax(ajaxOpt);
    };

    C.heartDrawPath = function (y) {
        var $elem = $('<div class="collect-heart on"></div>');
            $elem.css('position', 'fixed');
            $elem.css('right', '60px');
            $elem.css('top', y + 'px');
        var tsKey = transKey('ransition');
            $elem.css(tsKey, 'top 1s linear, right 0.5s ease-out');
            
        $(doc.body).append($elem);

        setTimeout(function () {
            $elem.css('top', '-10px');
            $elem.css('right', '180px');
        }, 10);

        setTimeout(function () {
            $elem.css('right', '50px');
        }, 500);
        
        setTimeout(function () {
            $elem.remove();
        }, 1300);
    };
})(window, document, Zepto);

function pageEnterEditMode() {
    $(document.body).addClass('edit');
}

function pageExitEditMode() {
    $(document.body).removeClass('edit');
}
