/***************************************************************************
 * 
 * Copyright (c) 2014 Baidu.com, Inc. All Rights Reserved
 * 
 **************************************************************************/
 
 
 
/**
 * @file js/tuangou.js
 * @author zhongligang01(zhongligang01@baidu.com)
 * @date 2014-09-03 22:28:11
 * @brief 
 *  
 **/
$(function() {
    var currentPage = 1;
    var pageSize = 10;
    var noMore = false;

    function showNoMore() {
        $('#tgMore').html('没有更多了');
    }

    function showLoading() {
        $('#tgMore').html('正在加载...');
    }

    function revertLoading() {
        $('#tgMore').html('查看更多团购');
    }

    function moreCallback(data) {
        revertLoading();
        if (data.status === 0 && data.data.count > 0) {
            $('#tgList').append($(data.data.html));
            if (data.data.count < pageSize) {
                noMore = true;
            }
        } else {
            noMore = true;
            showNoMore();
        }
    }

    $('#tgList li').live('click', function () {
        location.href = this.getAttribute('data-url');
    });

    $('#tgMore').on('click', function () {
        var hiddens, els;
        if (currentPage == 1) {
            hiddens = $('#tgList li.hidden');

            if (hiddens.size() > 0) {
                hiddens.removeClass('hidden');
                return;
            } else {
                els = $('#tgList li');
                if (els.size() < pageSize) {
                    noMore = true;
                    showNoMore();
                    return;
                }
            }
        }

        if (!noMore) {
            __tuangou_param.page = ++currentPage;
            showLoading();
            $.get('/searchv3/tuangou', __tuangou_param, moreCallback, 'json');
        } else {
            showNoMore();
        }
    });
});

/* vim: set expandtab ts=4 sw=4 sts=4 tw=100: */
