$(function(){
	/**
	 * 添加一组电话
	 */
	$(".main_table").delegate('.copy_add', 'click', function(e){
		var target = $(e.target).parents('.copy_father').find('.spec_table:first');
		var new_obj = target.clone();
		new_obj.find('.copy_del').css('display', 'block');
		target.parent().append(new_obj);
	});
	/**
	 * 删除一组电话
	 */
	$(".main_table").delegate('.copy_del', 'click', function(e){
		$(e.target).parents('.spec_table').remove();
	});
	/**
	 * 表单检查
	 * 
	 * @return pass 是否通过检查
	 */
	function form_check() {
		var pass = 1;
		$('input').each(function(){
			if($.trim($(this).val()) == '') {
				$(this).focus().css('background-color', '#FFFFCC');
				$(this).blur(function(){
					$(this).css('background-color', 'white');
				});
				pass = 0;
				return false;
			}
		});
		return pass;
	}
	/**
	 * 提交操作
	 */
	$('button').click(function(){
		if(!form_check()){
			alert('参数不能为空');
			return;
		}
		var content = $('form').serialize();
		$.ajax({
		    type:"post",
		    dataType: "json",
		    url:"/debug/searchsubmit",
		    data:{'content':content},
		    success:function(json){
		    	if (json.code == 1000) {
		    		alert('提交成功');
					return;
		    	} else {
		    		alert(json.msg);
					return;
		    	}
		    },
		    error:function(o,info){
		    	alert('请求失败(' + o.status + ')');
		    }
		});
	});
});