/***************************************************************************
 * 
 * Copyright (c) 2014 Baidu.com, Inc. All Rights Reserved
 * 
 **************************************************************************/
 
 
 
/**
 * @file ../../../webroot/js/searchv3.js
 * @author zhongligang01(zhongligang01@baidu.com)
 * @date 2014-09-04 11:43:20
 * @brief 
 *  
 **/

(function(){
    /* 所有的变量，都应该放在 ecom.wise 这个命名空间下。*/
    window.ecom = window.ecom || {};
    window.ecom.wise = window.ecom.wise || {};
    ecom.wise.js = ecom.wise.js || {};
    ecom.wise.lsJs = ecom.wise.lsJs || {};
    ecom.wise.css = ecom.wise.css || {};
    ecom.wise.succFlag = false;
    ecom.wise.adType = [];
    /*fclick日志类型AD:广告级REQUEST:请求级OTHER:其它*/
    window.ecom.wise.fclickType = {
        'AD': 'ad',
        'REQUEST': 'request',
        'OTHER': 'other',
        'NATURE': 'nature',
    };
})();

$('.content').delegate('ul.tj-ul li','click',function(e){
    var li = $(this)
    var callRcv = li.attr('call-rcv');//电话计费链接
    var name = li.attr('data-name');
    var phone = li.attr('data-phone');
    var detailUrl = li.attr('data-url');
    var type = 'NATURE';
    var fclickTag = '';
    var id = li.attr('data-id');
    if (li.hasClass('ec_ad')){
        type = 'AD';
    }
    var rank =  li.index() + 1;
    
    var $target = $(e.target);

    if ($target.closest('.conB').length) {  // 右侧箭头点击
        detailUrl = window.ecom.wise.ck.addCkOnUrl(detailUrl);
        fclickTag = 'dx-list-detail-click';
        ecomdx.jump(detailUrl,name);
    } else if ($target.closest('.collect-btn').length) {    // 收藏按钮点击

        if (ecom.wise.collect) {
            ecom.wise.collect.handleClickEvent($target, id, li);
        }

    } else { // 左侧大区域点击
        var fclickUrl = 'http://fclick.baidu.com/w.gif';
        var params = {};
        params.rank =rank;
        params.phone = phone;
        params.date = new Date().getTime();
        params.tag = 'dx-list-call';
        params.calltype = type;
        url = window.ecom.wise.global.getLogUrl(fclickUrl,params);
        if (callRcv) {
            ecom.wise.global.chargingRequest(callRcv);
        }

        Zt.dail(
            phone,
            name,
            callRcv,
            url
        );
        fclickTag = 'dx-list-direct-click';
    }
    ecom.wise.global.adFclick(fclickTag, this,{'phone' : phone,'rank':rank}, type);
});

$('ul.tj-ul').delegate('li','touchstart',function(e){
    var li = $(this);
    if ($(e.target).closest('.conB').length){
    	$('.bg').removeClass('bg');
        $('.bgw').removeClass('bgw');
        $(e.target).closest('li').find('.r').eq(0).addClass('bg');
        //$(e.target).closest('li').find('.r .conC').addClass('bgw');
    }else{ 
    	$('.bg').removeClass('bg');
        $('.bgw').removeClass('bgw');
        li.addClass('bg');
        li.find('div.r').addClass('bgw');
        //li.find('.r.text').addClass('bg');
    }
});

$('ul.tj-ul').delegate('li','touchend',function(e){
    	$('.bg').removeClass('bg');
	$('.bgw').removeClass('bgw');
});

$('ul.tj-ul').delegate('li','touchmove',function(e){
        $('.bg').removeClass('bg');
    $('.bgw').removeClass('bgw');
});

/* vim: set expandtab ts=4 sw=4 sts=4 tw=100: */
